Open In App

Count pairs having Bitwise XOR less than K from given array

Improve
Improve
Like Article
Like
Save
Share
Report

Given an array arr[]of size N and an integer K, the task is to count the number of pairs from the given array such that the Bitwise XOR of each pair is less than K
 Examples:

Input: arr = {1, 2, 3, 5} , K = 5 
Output:
Explanation: 
Bitwise XOR of all possible pairs that satisfy the given conditions are: 
arr[0] ^ arr[1] = 1 ^ 2 = 3 
arr[0] ^ arr[2] = 1 ^ 3 = 2 
arr[0] ^ arr[3] = 1 ^ 5 = 4 
arr[1] ^ arr[2] = 3 ^ 5 = 1 
Therefore, the required output is 4. 

Input: arr[] = {3, 5, 6, 8}, K = 7 
Output: 3  

Naive Approach: The simplest approach to solve this problem is to traverse the given array and generate all possible pairs of the given array and for each pair, check if bitwise XOR of the pair is less than K or not. If found to be true, then increment the count of pairs having bitwise XOR less than K. Finally, print the count of such pairs obtained.

C++




// C++ program to implement
// the above approach
#include <bits/stdc++.h>
using namespace std;
 
// Function to count pairs that
// satisfy the given conditions
int cntSmallerPairs(int arr[], int n,
                            int k) {
     
    int cnt = 0;
    // Loop through all possible pairs of elements in the array
    for (int i = 0; i < n; i++) {
        for (int j = i+1; j < n; j++) {
            // Check if bitwise XOR of the pair is less than K
            if ((arr[i] ^ arr[j]) < k) {
                cnt++;
            }
        }
    }
     
    // Print the count of pairs with bitwise XOR less than K
    cout << cnt << endl;
}
 
// Driver Code
int main()
{
    int arr[] = {3, 5, 6, 8};
    int K= 7;
    int N = sizeof(arr) / sizeof(arr[0]);
     
    cntSmallerPairs(arr, N, K);
}
 
// This code is contributed by Vaibhav


Java




// Java program to implement
// the above approach
import java.util.*;
 
class Main {
    // Function to count pairs that
    // satisfy the given conditions
    static int cntSmallerPairs(int arr[], int n, int k)
    {
        int cnt = 0;
        // Loop through all possible pairs of elements in
        // the array
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                // Check if bitwise XOR of the pair is less
                // than K
                if ((arr[i] ^ arr[j]) < k) {
                    cnt++;
                }
            }
        }
 
        // Return the count of pairs with bitwise XOR less
        // than K
        return cnt;
    }
 
    // Driver Code
    public static void main(String[] args)
    {
        int arr[] = { 3, 5, 6, 8 };
        int K = 7;
        int N = arr.length;
 
        int cnt = cntSmallerPairs(arr, N, K);
        // Print the count of pairs with bitwise XOR less
        // than K
        System.out.println(cnt);
    }
}
// This code is contributed by user_dtewbxkn77n


Python3




# Function to count pairs that
# satisfy the given conditions
 
 
def cntSmallerPairs(arr, n, k):
    cnt = 0
    # Loop through all possible pairs of elements in the array
    for i in range(n):
        for j in range(i+1, n):
            # Check if bitwise XOR of the pair is less than K
            if (arr[i] ^ arr[j]) < k:
                cnt += 1
    # Print the count of pairs with bitwise XOR less than K
    print(cnt)
 
 
# Driver Code
if __name__ == '__main__':
    arr = [3, 5, 6, 8]
    K = 7
    N = len(arr)
 
    cntSmallerPairs(arr, N, K)


C#




// C# program to implement
// the above approach
using System;
 
public class Program {
    // Function to count pairs that
    // satisfy the given conditions
    static void cntSmallerPairs(int[] arr, int n, int k)
    {
        int cnt = 0;
        // Loop through all possible pairs of elements in
        // the array
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                // Check if bitwise XOR of the pair is less
                // than K
                if ((arr[i] ^ arr[j]) < k) {
                    cnt++;
                }
            }
        }
        // Print the count of pairs with bitwise XOR less
        // than K
        Console.WriteLine(cnt);
    }
    // Driver Code
    public static void Main(string[] args)
    {
        int[] arr = { 3, 5, 6, 8 };
        int K = 7;
        int N = arr.Length;
 
        cntSmallerPairs(arr, N, K);
    }
}


Javascript




// Function to count pairs that satisfy the given conditions
function cntSmallerPairs(arr, n, k) {
    let cnt = 0;
    // Loop through all possible pairs of elements in the array
    for (let i = 0; i < n; i++) {
        for (let j = i + 1; j < n; j++) {
        // Check if bitwise XOR of the pair is less than K
            if ((arr[i] ^ arr[j]) < k) {
            cnt++;
            }
        }
    }
 
    // Return the count of pairs with bitwise XOR less than K
    return cnt;
}
 
// Driver Code
const arr = [3, 5, 6, 8];
const K = 7;
const N = arr.length;
 
const cnt = cntSmallerPairs(arr, N, K);
// Print the count of pairs with bitwise XOR less than K
console.log(cnt);


Output

3

Time Complexity:O(N2)
Auxiliary Space:O(1)

Efficient Approach: The problem can be solved using Trie. The idea is to iterate over the given array and for each array element, count the number of elements present in the Trie whose bitwise XOR with the current element is less than K and insert the binary representation of the current element into the Trie. Finally, print the count of pairs having bitwise XOR less than K. Follow the steps below to solve the problem:

Below is the implementation of the above approach:

C++




// C++ program to implement
// the above approach
 
#include <bits/stdc++.h>
using namespace std;
 
// Structure of Trie
struct TrieNode
{
    // Stores binary representation
    // of numbers
    TrieNode *child[2];
 
    // Stores count of elements
    // present in a node
    int cnt;
     
    // Function to initialize
    // a Trie Node
    TrieNode() {
        child[0] = child[1] = NULL;
        cnt = 0;
    }
};
 
 
// Function to insert a number into Trie
void insertTrie(TrieNode *root, int N) {
     
    // Traverse binary representation of X
    for (int i = 31; i >= 0; i--) {
         
        // Stores ith bit of N
        bool x = (N) & (1 << i);
         
        // Check if an element already
        // present in Trie having ith bit x
        if(!root->child[x]) {
             
            // Create a new node of Trie.
            root->child[x] = new TrieNode();
        }
         
        // Update count of elements
        // whose ith bit is x
        root->child[x]->cnt+= 1;
         
        // Update root
        root= root->child[x];
    }
}
 
 
// Function to count elements
// in Trie whose XOR with N
// less than K
int cntSmaller(TrieNode * root,
                int N, int K)
{
     
    // Stores count of elements
    // whose XOR with N less than K
    int cntPairs = 0;
     
    // Traverse binary representation
    // of N and K in Trie
    for (int i = 31; i >= 0 &&
                    root; i--) {
                                     
        // Stores ith bit of N                        
        bool x = N & (1 << i);
         
        // Stores ith bit of K
        bool y = K & (1 << i);
         
        // If the ith bit of K is 1
        if (y) {
             
            // If an element already
            // present in Trie having
            // ith bit (x)
            if(root->child[x]) {
                    cntPairs  +=
                    root->child[x]->cnt;
            }
         
            root =
                root->child[1 - x];
        }
         
        // If the ith bit of K is 0
        else{
             
            // Update root
            root = root->child[x];
        }
    }
    return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions
int cntSmallerPairs(int arr[], int N,
                            int K) {
     
    // Create root node of Trie
    TrieNode *root = new TrieNode();
     
    // Stores count of pairs that
    // satisfy the given conditions
    int cntPairs = 0;
     
    // Traverse the given array
    for(int i = 0;i < N; i++){
         
        // Update cntPairs
        cntPairs += cntSmaller(root,
                        arr[i], K);
         
        // Insert arr[i] into Trie
        insertTrie(root, arr[i]);
    }
    return cntPairs;
}
 
// Driver Code
int main()
{
    int arr[] = {3, 5, 6, 8};
    int K= 7;
    int N = sizeof(arr) / sizeof(arr[0]);
     
    cout<<cntSmallerPairs(arr, N, K);
}


Java




// Java program to implement
// the above approach
import java.util.*;
class GFG{
 
// Structure of Trie
static class TrieNode
{
  // Stores binary representation
  // of numbers
  TrieNode child[] = new TrieNode[2];
 
  // Stores count of elements
  // present in a node
  int cnt;
 
  // Function to initialize
  // a Trie Node
  TrieNode()
  {
    child[0] = child[1] = null;
    cnt = 0;
  }
};
 
 
// Function to insert a number
// into Trie
static void insertTrie(TrieNode root,
                       int N)
{   
  // Traverse binary representation
  // of X
  for (int i = 31; i >= 0; i--)
  {
    // Stores ith bit of N
    int x = (N) & (1 << i);
 
    // Check if an element already
    // present in Trie having ith
    // bit x
    if(x <2 && root.child[x] ==
       null)
    {
      // Create a new node of
      // Trie.
      root.child[x] = new TrieNode();
    }
 
    // Update count of elements
    // whose ith bit is x
    if(x < 2)
      root.child[x].cnt += 1;
 
    // Update root
    if(x < 2)
      root = root.child[x];
  }
}
 
// Function to count elements
// in Trie whose XOR with N
// less than K
static int cntSmaller(TrieNode root,
                      int N, int K)
{    
  // Stores count of elements
  // whose XOR with N less
  // than K
  int cntPairs = 0;
 
  // Traverse binary
  // representation of N
  // and K in Trie
  for (int i = 31; i >= 0 &&
       root != null; i--)
  {
    // Stores ith bit of N                        
    int x = (N & (1 << i));
 
    // Stores ith bit of K
    int y = (K & (1 << i));
 
    // If the ith bit of K
    // is 1
    if (y == 1)
    {
      // If an element already
      // present in Trie having
      // ith bit (x)
      if(root.child[x] != null)
      {
        cntPairs +=
           root.child[x].cnt;
      }
 
      root = root.child[1 - x];
    }
 
    // If the ith bit of K is 0
    else
    {
      // Update root
      if(x < 2)
        root = root.child[x];
    }
  }
  return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions
static int cntSmallerPairs(int arr[],
                           int N, int K)
{   
  // Create root node of Trie
  TrieNode root = new TrieNode();
 
  // Stores count of pairs that
  // satisfy the given conditions
  int cntPairs = 0;
 
  // Traverse the given array
  for(int i = 0; i < N; i++)
  {
    // Update cntPairs
    cntPairs += cntSmaller(root,
                           arr[i], K);
 
    // Insert arr[i] into Trie
    insertTrie(root, arr[i]);
  }
  return cntPairs;
}
 
// Driver Code
public static void main(String[] args)
{
  int arr[] = {3, 5, 6, 8};
  int K= 7;
  int N = arr.length;
  System.out.print(cntSmallerPairs(arr,
                                   N, K));
}
}
 
// This code is contributed by Rajput-Ji


Python3




# Python3 program to implement
# the above approach
  
# Structure of Trie
class TrieNode:
 
    # Function to initialize
    # a Trie Node
    def __init__(self):       
        self.child = [None, None]
        self.cnt = 0
 
# Function to insert a number into Trie
def insertTrie(root, N):
      
    # Traverse binary representation of X.
    for i in range(31, -1, -1):
              
        # Stores ith bit of N
        x = bool( (N) & (1 << i));
          
        # Check if an element already
        # present in Trie having ith bit x.
        if(root.child[x] == None):
              
            # Create a new node of Trie.
            root.child[x] = TrieNode();
                  
        # Update count of elements
        # whose ith bit is x
        root.child[x].cnt += 1;
          
        # Update root.
        root= root.child[x];
   
# Function to count elements
# in Trie whose XOR with N
# less than K
def cntSmaller(root, N, K):
      
    # Stores count of elements
    # whose XOR with N exceeding K
    cntPairs = 0;
      
    # Traverse binary representation
    # of N and K in Trie
    for i in range(31, -1, -1):      
        if(root == None):
            break
                                     
        # Stores ith bit of N                        
        x = bool(N & (1 << i))
          
        # Stores ith bit of K
        y = K & (1 << i);
          
        # If the ith bit of K is 1
        if (y != 0):
             
            # If an element already
            # present in Trie having
            # ith bit (1 - x)
            if (root.child[x]):
 
                # Update cntPairs
                cntPairs += root.child[ x].cnt
 
            # Update root.
            root = root.child[1 - x];
          
        # If the ith bit of K is 0
        else:
              
            # Update root.
            root = root.child[x]
    return cntPairs;
  
# Function to count pairs that
# satisfy the given conditions.
def cntSmallerPairs(arr, N, K):
      
    # Create root node of Trie
    root = TrieNode();
      
    # Stores count of pairs that
    # satisfy the given conditions
    cntPairs = 0;
      
    # Traverse the given array.
    for i in range(N):
          
        # Update cntPairs
        cntPairs += cntSmaller(root, arr[i], K);
          
        # Insert arr[i] into Trie.
        insertTrie(root, arr[i]);   
    return cntPairs;
  
# Driver code
if __name__=='__main__':
    arr = [3, 5, 6, 8]
    K= 7;
    N = len(arr)    
    print(cntSmallerPairs(arr, N, K))
 
    # This code is contributed by rutvik_56


C#




// C# program to implement
// the above approach
using System;
 
class GFG{
 
// Structure of Trie
public class TrieNode
{
   
  // Stores binary representation
  // of numbers
  public TrieNode []child = new TrieNode[2];
 
  // Stores count of elements
  // present in a node
  public int cnt;
 
  // Function to initialize
  // a Trie Node
  public TrieNode()
  {
    child[0] = child[1] = null;
    cnt = 0;
  }
};
 
// Function to insert a number
// into Trie
static void insertTrie(TrieNode root,
                       int N)
{
   
  // Traverse binary representation
  // of X
  for(int i = 31; i >= 0; i--)
  {
     
    // Stores ith bit of N
    int x = (N) & (1 << i);
 
    // Check if an element already
    // present in Trie having ith
    // bit x
    if (x < 2 && root.child[x] == null)
    {
       
      // Create a new node of
      // Trie.
      root.child[x] = new TrieNode();
    }
 
    // Update count of elements
    // whose ith bit is x
    if (x < 2)
      root.child[x].cnt += 1;
 
    // Update root
    if (x < 2)
      root = root.child[x];
  }
}
 
// Function to count elements
// in Trie whose XOR with N
// less than K
static int cntSmaller(TrieNode root,
                      int N, int K)
{   
   
  // Stores count of elements
  // whose XOR with N less
  // than K
  int cntPairs = 0;
 
  // Traverse binary
  // representation of N
  // and K in Trie
  for(int i = 31; i >= 0 &&
      root != null; i--)
  {
     
    // Stores ith bit of N                        
    int x = (N & (1 << i));
 
    // Stores ith bit of K
    int y = (K & (1 << i));
 
    // If the ith bit of K
    // is 1
    if (y == 1)
    {
       
      // If an element already
      // present in Trie having
      // ith bit (x)
      if (root.child[x] != null)
      {
        cntPairs += root.child[x].cnt;
      }
       
      root = root.child[1 - x];
    }
 
    // If the ith bit of K is 0
    else
    {
       
      // Update root
      if (x < 2)
        root = root.child[x];
    }
  }
  return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions
static int cntSmallerPairs(int []arr,
                           int N, int K)
{   
   
  // Create root node of Trie
  TrieNode root = new TrieNode();
 
  // Stores count of pairs that
  // satisfy the given conditions
  int cntPairs = 0;
 
  // Traverse the given array
  for(int i = 0; i < N; i++)
  {
     
    // Update cntPairs
    cntPairs += cntSmaller(root,
                           arr[i], K);
 
    // Insert arr[i] into Trie
    insertTrie(root, arr[i]);
  }
  return cntPairs;
}
 
// Driver Code
public static void Main(String[] args)
{
  int []arr = { 3, 5, 6, 8 };
  int K= 7;
  int N = arr.Length;
   
  Console.Write(cntSmallerPairs(arr,
                                N, K));
}
}
 
// This code is contributed by Princi Singh


Javascript




// Javascript program to implement
// the above approach
 
// Structure of Trie
class TrieNode
{
    constructor()
    {
        // Stores binary representation
        // of numbers
        this.child = new Array(2);
         
        // Stores count of elements
        // present in a node
        this.cnt = 0;
         
        // initialize
        // a Trie Node
        this.child[0] = this.child[1] = null;
    }
}
 
// Function to insert a number
// into Trie
function insertTrie(root,N)
{
 
    // Traverse binary representation
// of X.
for (let i = 31; i >= 0; i--)
{
 
    // Stores ith bit of N
    let x = (N) & (1 << i);
 
    // Check if an element already
    // present in Trie having ith
    // bit x.
    if (x < 2 && root.child[x] == null)
    {
    // Create a new node of Trie.
    root.child[x] = new TrieNode();
    }
 
    // Update count of elements
    // whose ith bit is x
    if(x < 2 )
    root.child[x].cnt += 1;
 
    // Update root.
    if(x < 2 )
    root = root.child[x];
}
}
 
// Function to count elements
// in Trie whose XOR with N
// less than K
function cntSmaller(root, N, K)
{
 
    // Stores count of elements
    // whose XOR with N less than K
let cntPairs = 0;
 
// Traverse binary representation
// of N and K in Trie
for (let i = 31; i >= 0 &&
        root!=null; i--)
{
    // Stores ith bit of N
    let x = N & (1 << i);
 
    // Stores ith bit of K
    let y = K & (1 << i);
 
    // If the ith bit of K is 1
    if (y)
    {
            // If an element already
            // present in Trie having
            // ith bit (x)
             
            if (root.child[x] != null)
       {
        cntPairs += root.child[x].cnt;
       }
        
        root = root.child[1-x];
 
    }
 
    // If the ith bit of K is 0
    else
    {
        // Update root
        if(x < 2)
        root = root.child[x];
    }
}
return cntPairs;
}
 
// Function to count pairs that
// satisfy the given conditions.
function cntGreaterPairs(arr,N,K)
{
    // Create root node of Trie
let root = new TrieNode();
 
// Stores count of pairs that
// satisfy the given conditions
let cntPairs = 0;
 
// Traverse the given array.
for (let i = 0; i < N; i++)
{
    // Update cntPairs
    cntPairs += cntSmaller(root,
                        arr[i], K);
 
    // Insert arr[i] into Trie.
    insertTrie(root, arr[i]);
}
return cntPairs;
}
 
// Driver code
let arr=[3, 5, 6, 8];
let K = 7;
let N = arr.length;
console.log(cntGreaterPairs(arr,N, K));
     
// This code is contributed by Pushpesh Raj


Output: 

3

 

Time Complexity:O(N * 32)
Auxiliary Space:O(N * 32)



Last Updated : 04 Apr, 2023
Like Article
Save Article
Previous
Next
Share your thoughts in the comments
Similar Reads